
Partial Class GridGroupingWithMaster
    Inherits System.Web.UI.Page

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        'Setting the TableDescriptor's PrimaryKeyColumns here is easier on the designer. 
        'I find when I set it in the controls property screen the designer craps out. 
        Me.GridGroupingControl1.TableDescriptor.PrimaryKeyColumns.Add(New Syncfusion.Grouping.SortColumnDescriptor("ID"))
        Page.DataBind()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Note - we don't bind here. 
    End Sub

    Protected Sub GridGroupingControl1_CurrentRecordContextChange(ByVal sender As Object, ByVal e As Syncfusion.Grouping.CurrentRecordContextChangeEventArgs) Handles GridGroupingControl1.CurrentRecordContextChange
        If e.Action = Syncfusion.Grouping.CurrentRecordAction.EndEditComplete Then
            Dim fac As Facility
            ' This is a Facility instance that was modified
            fac = e.Record.GetData()

            ' Update your "data source" appropriately here, so that the next time DataBind is called on a postback,
            ' it will include appropriate data (this logic is not implemented here)
            If e.Record.Kind = Syncfusion.Grouping.DisplayElementKind.AddNewRecord Then
                ' This record was added
                ' If this is a record-addition, finally refresh the grid's binding
                Me.GridGroupingControl1.Table.TableDirty = True
            Else
                ' This record was edited.
            End If
        End If

    End Sub

    Protected Sub GridGroupingControl1_RecordDeleting(ByVal sender As Object, ByVal e As Syncfusion.Grouping.RecordEventArgs) Handles GridGroupingControl1.RecordDeleting
        Dim fac As Facility
        ' This is a Facility instance that will be deleted from the FacilityCollection after this handler returns.
        fac = e.Record.GetData()
    End Sub
    Protected Sub GridGroupingControl1_RecordDeleted(ByVal sender As Object, ByVal e As Syncfusion.Grouping.RecordEventArgs) Handles GridGroupingControl1.RecordDeleted
        ' This will be called after deleting the Facility instance from the collection.
        ' Here you cannot access the Facility instance that is already removed.

        ' You can access the collection as follows:
        Dim list As FacilityCollection
        list = Me.GridGroupingControl1.Engine.GetSourceList()

        ' Update your "data source" appropriately here, so that the next time DataBind is called on a postback,
        ' it will include appropriate data (this logic is not implemented here)

        ' If this is a delete, finally refresh the grid's binding
        Me.GridGroupingControl1.Table.TableDirty = True
    End Sub

End Class
